#include "bit.h"
#include <stdio.h>
#include <assert.h>

int bit_count(unsigned long long nb);

int fsb_pos(unsigned long long i);

void print_bits(unsigned long long x, int bits)
{
    while (bits --) {
        printf("%d", BS_SET(x, bits) != 0);
    }
}

unsigned long long convert_endian2n(int size, const unsigned char data[], enum endian endianness)
{
    unsigned long long r = 0;
    int offset = (endianness == BIG) ? 0 : size - 1;
    int direction = (endianness == BIG) ? 1 : -1;
    while (size --) {
        r = (r << 8) | data[offset];
        offset += direction;
    }
    return r;
}

unsigned long long extract_littleendian2n(int size, unsigned char *data, int offset)
{
    unsigned long long r = 0;
    while (size --)
        r = (r << 8) | data[offset + size];
    return r;
}
