#include <errno.h>
#include <assert.h>

#include <stdio.h> /* fopen, fread, fwrite*/
#include <stdlib.h> /* malloc, exite*/
#include <string.h> /* memset */
#include <strings.h> /* ffs */

#include "bit.h"
#include "buzzer.h"

static const char *buttons_txt[] = {
    "RED", "YELLOW", "GREEN", "ORANGE", "BLUE"
};

FILE *open_buzzer(const char *fname);

int send_status(FILE *fd, unsigned long long *buffer);

void reset_buffer(unsigned long long *buffer);

void set_lights(int bitset, unsigned long long *buffer);

int read_status(FILE *fd, unsigned long long *status);

int has_played(unsigned long long *w);

void animate(int repeat, unsigned int interval, int animcount, unsigned long long *animation[], FILE* fd);

const char *button_name(enum Buttons b)
{
    if (b >= RED || b <= BLUE)
        return buttons_txt[b];
    return "UNKOWN";
}

void exit_if(int condition, const char *msg)
{
    if (condition) {
        perror(msg);
        exit(EXIT_FAILURE);
    }
}
