#include <stdio.h> // for printf, fopen, ...
#include <stdlib.h> // for atexit, EXIT_SUCCESS
#include <assert.h>
#include <signal.h>

#include "bit.h"
#include "buzzer.h"

FILE *fd; // fd should be global for `clean_up`

static void clean_up()
{
    if (fd) fclose(fd);
    printf("\nExiting ...\n");
    exit(EXIT_SUCCESS);
}

int main(int argc, char *argv[])
{
    char *device = (argc > 1) ? argv[1] : INPUT_DEVICE;

    fd = fopen(device, "r+");
    exit_if(fd == NULL, "Impossible d'ouvrir les buzzers");
    setbuf(fd, NULL); // Désactive le `buffering` sur fd

    // Active la fonction `clean_up` comme fonction de sortie
    // atexit(clean_up);
    exit_if(signal(SIGINT, clean_up) == SIG_ERR, "Can't trap Ctrl-C");
    exit_if(signal(SIGTERM, clean_up) == SIG_ERR, "Can't trap Ctrl-C");

    while (!feof(fd)) {
    }

    // If this line is reached, it means that fd is reporting failure
    return EXIT_FAILURE;
}
